using System;
using TMPro;
using UnityEngine;

public class StartUIManager : MonoBehaviour
{
    public int WaitTimeLimit = 45;
    public GameObject SceneLoaderObj;
    public GameObject StartSceneDataObj;
    public TextMeshProUGUI MessageTextObj;
    public TextMeshProUGUI WaitTimeTextObj;
    private SceneLoader sceneLoader;
    private StartSeneData startSceneData;
    private float startTime;
    private float nowTime;
    // Start is called before the first frame update
    void Start()
    {
        sceneLoader = SceneLoaderObj.GetComponent<SceneLoader>();
        startSceneData = StartSceneDataObj.GetComponent<StartSeneData>();
        MessageTextObj.text = "";
    }

    private void Update()
    {
        // update time limit left;
        float leftTime = WaitTimeLimit - Time.realtimeSinceStartup;
        WaitTimeTextObj.text = ((int)Math.Round(leftTime)).ToString();
        if (leftTime <= 1)
        {
            // if time limit is over, load Train Scene
            sceneLoader.loadScene(SceneLoader.SceneType.Train);
        }

    }

    // while Train-StartButton Pressed
    public void OnTrainStartButtonPressed()
    {
        startSceneData.gamemode = 0;
        sceneLoader.loadScene(SceneLoader.SceneType.Train);
        MessageTextObj.text = "Loading Train Scene...";
    }
    // while StartButton-Play Pressed
    public void OnPlayButtonPressed()
    {
        startSceneData.gamemode = 1;
        sceneLoader.loadScene(SceneLoader.SceneType.Play);
        MessageTextObj.text = "Loading Play Scene...";
    }
    
}
